package com.elephant.framework.galaxy.aroad.module.zhtj.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.elephant.framework.galaxy.aroad.module.zhtj.entity.ZhtjGljbxxGlmd;
import com.elephant.framework.galaxy.aroad.module.zhtj.service.ZhtjGljbxxGlmdService;
import com.elephant.framework.galaxy.aroad.response.R;
import com.elephant.framework.galaxy.aroad.module.common.annotation.SysLog;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.elephant.framework.galaxy.aroad.module.common.controller.BaseController;


/**
 * 公路密度
 *
 * @author xuzhitu
 * @date 2019-03-12 21:59:19
 */
@RestController
@AllArgsConstructor
@RequestMapping("/zhtj/zhtjgljbxxglmd")
public class ZhtjGljbxxGlmdController extends BaseController  {

  private final ZhtjGljbxxGlmdService zhtjGljbxxGlmdService;

  /**
   * 分页查询
   * @param page 分页对象
   * @param zhtjGljbxxGlmd 公路密度
   * @return
   */
  @GetMapping("/page")
  public R getZhtjGljbxxGlmdPage(Page page, ZhtjGljbxxGlmd zhtjGljbxxGlmd) {
    if(zhtjGljbxxGlmd.getYear() == null){
      zhtjGljbxxGlmd.setYear("2018");
    }
    return  new R<>(zhtjGljbxxGlmdService.page(page,Wrappers.query(zhtjGljbxxGlmd)));
  }


  /**
   * 通过id查询公路密度
   * @param id id
   * @return R
   */
  @GetMapping("/{id}")
  public R getById(@PathVariable("id") Integer id){
    return new R<>(zhtjGljbxxGlmdService.getById(id));
  }

  /**
   * 新增公路密度
   * @param zhtjGljbxxGlmd 公路密度
   * @return R
   */
  @SysLog("新增公路密度")
  @PostMapping
  public R save(@RequestBody ZhtjGljbxxGlmd zhtjGljbxxGlmd){
    return new R<>(zhtjGljbxxGlmdService.save(zhtjGljbxxGlmd));
  }

  /**
   * 修改公路密度
   * @param zhtjGljbxxGlmd 公路密度
   * @return R
   */
  @SysLog("修改公路密度")
  @PutMapping
  public R updateById(@RequestBody ZhtjGljbxxGlmd zhtjGljbxxGlmd){
    return new R<>(zhtjGljbxxGlmdService.updateById(zhtjGljbxxGlmd));
  }

  /**
   * 通过id删除公路密度
   * @param id id
   * @return R
   */
  @SysLog("删除公路密度")
  @DeleteMapping("/{id}")
  public R removeById(@PathVariable Integer id){
    return new R<>(zhtjGljbxxGlmdService.removeById(id));
  }

}
